<%
' Copyright (C) 2000, 2001 Wu Yongwei. All rights reserved.
'
' Version:            1.04.0004
' Original Author:    Wu Yongwei
' Creation Date:      13 Mar 2000
' Last Update:        02 Nov 2001
' Modified By:
' Modification Date:
'

Option Explicit
Response.Buffer = True
Dim Referrer, UserID, Password, EncPwd, UserStatus, Remember, CurTime, I, Ch
%>
<!-- #include virtual="/common/common.inc" -->
<!-- #include virtual="/common/login.inc" -->
<!-- #include virtual="/common/logout.inc" -->
<!-- #include virtual="/common/pjmd5.inc" -->
<!-- #include virtual="/common/rc4.inc" -->
<%
Referrer = Request.ServerVariables("HTTP_REFERER")
If Not IsEmpty(Request("referrer")) Then Referrer = Request("referrer")  ' Custom referrer always overrides HTTP header
If Referrer = "" Or InStr(Referrer, "relogin.asp") Then Referrer = "/"

If Not IsEmpty(Session("userid")) Then  ' If already logged in
  Response.Redirect "relogin.asp?referrer=" & Server.URLEncode(Referrer)
  Response.End
End If

UserID = Request.Form("userid")
Password = Request.Form("password")
Remember = Request.Form("remember")

If IsEmpty(Password) Then
  EncPwd = Request.Cookies("USERINFO")("MAGICNUM")  ' Get encrypted password
  If Left(EncPwd,4) = "FFFE" Then  ' MAGICNUM must begin with "FFFE"
    UserID = Request.Cookies("USERINFO")("USERID")  ' Get UserID
    If Not IsEmpty(UserID) Then
      EncPwd = UCase(Mid(EncPwd, 5))
      For I = 1 To Len(EncPwd)  ' Check validity
        Ch = Mid(EncPwd, I, 1)
        If Ch < "0" Or (Ch > "9" And Ch < "A") Or Ch > "F" Then Exit For
      Next
      If I > Len(EncPwd) Then  ' If EncPwd is valid
        EncPwd = EnDeCrypt(BinFromHex(EncPwd), Application("enckey"))  ' Decrypt EncPwd
        If Left(EncPwd, 2) = "~`" Then
          Password = Mid(EncPwd, 3)  ' Password does not include two leading characters
          Remember = "p"  ' Remember me next time
        End If
      End If
    End If
  End If
End If

If Not IsEmpty(UserID) And Not IsEmpty(Password) Then
  UserID = LCase(UserID)
  If Not IsEmpty(Application("channel_" & UserID)) Then  ' If the user is still on-line
    If Request.Cookies("SESSIONID") = Application("sessionid_" & UserID) Then  ' Who exited without logging out
      Logout UserID, Now  ' Clear hanging user
    End If
  End If
  If IsEmpty(Application("channel_" & UserID)) Then
    If Login(UserID, Password, UserStatus) Then
      Select Case Remember
        Case "u"
          Response.Cookies("USERINFO") = ""
          Response.Cookies("USERINFO")("USERID") = UserID
          Response.Cookies("USERINFO")("REMEMBER") = "u"
          Response.Cookies("USERINFO").Expires = DateAdd("m", 6, Now)
        Case "p"
          Response.Cookies("USERINFO") = ""
          Response.Cookies("USERINFO")("USERID") = UserID
          Response.Cookies("USERINFO")("MAGICNUM") = "FFFE" & BinToHex(EnDeCrypt("~`" + Password, Application("enckey")))
          Response.Cookies("USERINFO")("REMEMBER") = "p"
          Response.Cookies("USERINFO").Expires = DateAdd("m", 6, Now)
        Case Else
          Response.Cookies("USERINFO").Expires = #1 Jan 1980#
      End Select
      Response.Redirect Referrer
      Response.End
    End If
  Else
    UserStatus = "ûѵ¼"
  End If
Else
  UserStatus = Empty  ' Clear user status if no submission has occurred
End If

If IsEmpty(Remember) Then Remember = Request.Cookies("USERINFO")("REMEMBER")
CurTime = Now
Session("challenge") = "<" & Session.SessionID & "." & FormatDate(CurTime) & " " & TimeValue(CurTime) & ">"
%>
<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>û¼</title>
<meta http-equiv="Content-Type" content="text/html; charset=gb2312">
<% If IsEmpty(Request.Form) Then %><meta http-equiv="Pragma" content="no-cache"><% End If %>
<meta name="Author" content="Wu Yongwei">
<link rel="stylesheet" type="text/css" href="/common/style.css">
<script language="JavaScript" src="/common/pjmd5.js"></script>
<script language="JavaScript">
<!--
document.cookie = "COOKIESUPPORTED=TRUE; path=/";

function disableSafeLogin()
{
  document.LoginForm.safelogin.checked = false;
  document.LoginForm.safelogin.disabled = true;
}

function enableSafeLogin()
{
  document.LoginForm.safelogin.disabled = false;
  document.LoginForm.safelogin.checked = true;
}

function encryptPassword()
{
  if (document.LoginForm.safelogin.checked && !document.LoginForm.safelogin.disabled)
    document.LoginForm.password.value = calcMD5(document.LoginForm.challenge.value + document.LoginForm.password.value);
}

function startup()
{
  if (document.cookie == '')
    alert('֧ Cookie');
  if (document.LoginForm.remember[1].checked)
    disableSafeLogin();
  else
    enableSafeLogin();
  if (document.LoginForm.userid.value == '')
    document.LoginForm.userid.focus();
  else
    document.LoginForm.password.focus();
}
//-->
</script>
</head>

<body onload="startup()">

<form name="LoginForm" method="post" action="login.asp" onsubmit="encryptPassword()">
<input type="hidden" name="challenge" value="<%= Server.HTMLEncode(Session("challenge")) %>">
<table width="300" border="0" align="center">
  <tr>
    <td height="80" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="90">û</td>
    <td>
      <input type="text" name="userid" size="16" maxlength="16" value="<% If Not IsEmpty(UserID) Then Response.Write Server.HTMLEncode(UserID) Else Response.Write Request.Cookies("USERINFO")("USERID") %>">
    </td>
  </tr>
  <tr>
    <td>룺</td>
    <td>
      <input type="password" name="password" size="16" maxlength="32">
    </td>
  </tr>
  <tr>
    <td></td>
    <td>
      <small>&nbsp;
      <br><input type="checkbox" name="referrer" <% If Referrer = "" Then Response.Write "disabled" Else Response.Write "value=""" & Server.HTMLEncode(Referrer) & """ checked" %>>
      ¼󷵻ǰһҳ
      <br><input type="checkbox" name="safelogin">
      ȫ¼ĴͿ</small>
    </td>
  </tr>
  <tr>
    <td></td>
    <td>
      <small><input type="radio" name="remember" value="u"<%= Check(Remember, "u") %> onclick="enableSafeLogin()"> סû
      <br><input type="radio" name="remember" value="p"<%= Check(Remember, "p") %> onclick="disableSafeLogin()"> סûͿ
      <br><input type="radio" name="remember" value=""<%= Check(Remember, "") %> onclick="enableSafeLogin()"> ûͿ
      <br>&nbsp;</small>
    </td>
  </tr>
  <tr>
    <td>
      <input type="submit" value="¼" class="small">
    </td>
    <td>
      <input type="reset" value="" class="small">
    </td>
  </tr>
  <tr>
    <td colspan="2" class="small">&nbsp;<font color="red"><%= UserStatus %></font></td>
  </tr>
</table>
</form>

<noscript>
<center><font color="red">֧<span class="latin"> JavaScript</span></font></center>
</noscript>

</body>
</html>