<SCRIPT LANGUAGE="VBScript" RUNAT="Server">
' Copyright (C) 2000, 2001 Wu Yongwei. All rights reserved.
'
' Version:            1.01.0006
' Original Author:    Wu Yongwei
' Creation Date:      15 Mar 2000
' Last Update:        11 Oct 2001
' Modified By:
' Modification Date:
'

' Constant definition
Const Quot = """"

' Client-side redirection (for better compatibility with Netscape browsers)
Sub Redirect(URL)
  Response.Write "<" & "script language=""JavaScript"">" & vbCRLF & _
                 "<" & "!--" & vbCRLF & _
                 "  location.href=""" & URL & """;" & vbCRLF & _
                 "//-->" & vbCRLF & _
                 "<" & "/script></body></html>"
End Sub

' Display some text (HTML not allowed)
Sub Text(Str)
  If Not IsNull(Str) Then
    Response.Write Replace(Server.HTMLEncode(Str), vbNewLine, "<br>" & vbNewLine)
  End If
End Sub

' Emulate the Visual Basic function IIf
Function IIf(Cond, TValue, FValue)
  If Cond Then IIf = TValue Else IIf = FValue
End Function

' Convert hexadecimal codes to the corresponding binary stream
Function BinFromHex(TextStream)
  Dim I, Result
  For I = 1 To Len(TextStream) Step 2
    Result = Result & ChrB(CInt("&H" & Mid(TextStream, I , 2)))
  Next
  BinFromHex = Result
End Function

' Convert a binary stream to its corresponding hexadecimal codes
Function BinToHex(BinaryStream)
  BinToHex = BinToHexEx(BinaryStream, "")
End Function

' Convert a binary stream to its corresponding hexadecimal codes with separator
Function BinToHexEx(BinaryStream, Separator)
  Dim I, HexCode, Result
  For I = 1 To LenB(BinaryStream)
    HexCode = Hex(AscB(MidB(BinaryStream, I, 1)))
    If Len(HexCode) = 1 Then HexCode = "0" & HexCode
    Result = Result & HexCode & Separator
  Next
  BinToHexEx = Left(Result, Len(Result) - Len(Separator))
End Function

' ROT13 encode/decode
Function Rot13(Str)
  Dim I, C, K, Result
  Result = ""
  For I = 1 to Len(Str)
    C = Mid(Str, I, 1)
    K = Asc(C)
    If K >= 97 and K =< 109 then
      K = K + 13 ' a..m inclusive become n..z
    ElseIf K >= 110 and K =< 122 then
      K = K - 13 ' n..z inclusive become a..m
    ElseIf K >= 65 and K =< 77 then
      K = K + 13 ' A..M inclusive become N..Z
    ElseIf K >= 78 and K =< 90 then
      K = K - 13 ' N..Z inclusive become A..M
    End If
  Result = Result & Chr(K)
  Next
  Rot13 = Result
End Function

' Replace the single quotes in a string for use in SQL statements
Function SQEncode(Str)
  SQEncode = Replace(Str, "'", "''")
End Function

' Enclose a date with "#" (for use with Access); change to "'" if using SQL Server
Function SDate(theDate)
  SDate = "#" & theDate & "#"
End Function

' Format a date for display in four-digit years
Function FormatDate(theDate)
  If IsDate(theDate) Then
    FormatDate = Year(theDate) & "-" & Month(theDate) & "-" & Day(theDate)
  Else
    FormatDate = theDate
  End If
End Function

' Ease the display of the CHECKED state in a checkbox
Function Check(Str1, Str2)
  If Str1 = Str2 Then Check = " checked" Else Check = ""
End Function

' Check whether a character is one of letters, digits, and underline
Function IsCSym(Ch)
  Ch = LCase(Ch)
  If (Ch >= "0" And Ch <= "9") Or (Ch >= "a" And Ch <= "z") Or Ch = "_" Then IsCSym = True Else IsCSym = False
End Function

' Check whether a non-empty string contains only letters, numbers, and underline
Function IsValidID(Str)
  Dim I, L

  Str = Trim(Str)
  If Str = "" Then
    IsValidID = False
    Exit Function
  Else
    IsValidID = True
  End If

  L = Len(Str)
  For I = 1 To L
    If Not IsCSym(Mid(Str, I, 1)) Then
      IsValidID = False
      Exit For
    End If
  Next
End Function
</SCRIPT>